var __decorate=this&&this.__decorate||function(f,l,m,n){var d=arguments.length,a=d<3?l:n===null?n=Object.getOwnPropertyDescriptor(l,m):n,h;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")a=Reflect.decorate(f,l,m,n);else for(var o=f.length-1;o>=0;o--)(h=f[o])&&(a=(d<3?h(a):d>3?h(l,m,a):h(l,m))||a);return d>3&&a&&Object.defineProperty(l,m,a),a},__param=this&&this.__param||function(f,l){return function(m,n){l(m,n,f)}};define(["require","exports","vs/base/common/lifecycle","vs/base/common/objects","vs/base/common/observableValue","vs/base/common/platform","vs/base/common/strings","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils"],function(f,l,m,n,d,a,h,o,S,T,p,x,E,g,I){"use strict";Object.defineProperty(l,"__esModule",{value:!0}),l.TelemetryService=void 0;let y=class{constructor(e,r,t){this._configurationService=r,this._productService=t,this._experimentProperties={},this.telemetryLevel=new d.MutableObservableValue(3),this._disposables=new m.DisposableStore,this._cleanupPatterns=[],this._appenders=e.appenders,this._commonProperties=e.commonProperties||Promise.resolve({}),this._piiPaths=e.piiPaths||[],this._sendErrorTelemetry=!!e.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let i of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,h.escapeRegExpCharacters)(i),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(e,r){this._experimentProperties[e]=r}_updateTelemetryLevel(){let e=(0,I.getTelemetryLevel)(this._configurationService);const r=this._productService.enabledTelemetryLevels;if(r){this._sendErrorTelemetry=this.sendErrorTelemetry?r.error:!1;const t=r.usage?3:r.error?2:0;e=Math.min(e,t)}this.telemetryLevel.value=e}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const e=await this._commonProperties;let r=e.sessionID,t=e["common.machineId"],i=e["common.firstSessionDate"],c=e["common.msftInternal"];return{sessionId:r,machineId:t,firstSessionDate:i,msftInternal:c}}dispose(){this._disposables.dispose()}_log(e,r,t,i){return this.telemetryLevel.value<r?Promise.resolve(void 0):this._commonProperties.then(c=>{t=(0,n.mixin)(t,c),t=(0,n.mixin)(t,this._experimentProperties),t=(0,n.cloneAndChange)(t,s=>{if(typeof s=="string")return this._cleanupInfo(s,i)}),this._appenders.forEach(s=>s.log(e,t))},c=>{console.error(c)})}publicLog(e,r,t){return this._log(e,3,r,t)}publicLog2(e,r,t){return this.publicLog(e,r,t)}publicLogError(e,r){return this._sendErrorTelemetry?this._log(e,2,r,!0):Promise.resolve(void 0)}publicLogError2(e,r){return this.publicLogError(e,r)}_anonymizeFilePaths(e){let r=e;const t=[];for(let u of this._cleanupPatterns)for(;;){const v=u.exec(e);if(!v)break;t.push([v.index,u.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(r="";;){const u=c.exec(e);if(!u)break;!i.test(u[0])&&t.every(([v,_])=>u.index<v||u.index>=_)&&(r+=e.substring(s,u.index)+"<REDACTED: user-file-path>",s=c.lastIndex)}return s<e.length&&(r+=e.substr(s)),r}_removePropertiesWithPossibleUserInfo(e){if(!e)return e;const r=e.toLowerCase(),t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const i of t)if(i.regex.test(r))return`<REDACTED: ${i.label}>`;return e}_cleanupInfo(e,r){let t=e;r&&(t=this._anonymizeFilePaths(t));for(let i of this._cleanupPatterns)t=t.replace(i,"");return t=this._removePropertiesWithPossibleUserInfo(t),t}};l.TelemetryService=y,y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",l.TelemetryService=y=__decorate([__param(1,S.IConfigurationService),__param(2,x.IProductService)],y);function P(){const b=(0,o.localize)(0,null,p.default.nameLong),e=p.default.privacyStatementUrl?(0,o.localize)(2,null,"https://aka.ms/vscode-telemetry",p.default.privacyStatementUrl):(0,o.localize)(1,null,"https://aka.ms/vscode-telemetry"),r=a.isWeb?"":(0,o.localize)(3,null),t=(0,o.localize)(4,null),i=(0,o.localize)(5,null),c=(0,o.localize)(6,null),s=(0,o.localize)(7,null),u=`
|       | ${t} | ${i} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,v=(0,o.localize)(8,null);return`
${b} ${e} ${r}

&nbsp;

${s}
${u}

&nbsp;

${v}
`}E.Registry.as(T.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,o.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,o.localize)(10,null),(0,o.localize)(11,null),(0,o.localize)(12,null),(0,o.localize)(13,null)],markdownDescription:P(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(T.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,o.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,o.localize)(16,null,p.default.nameLong,p.default.privacyStatementUrl):(0,o.localize)(15,null,p.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,o.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})});

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1f71e2df4a5c741d4a3b7214135be70fa059cd16/core/vs/platform/telemetry/common/telemetryService.js.map
